//---------------------------------------------------------------------------

#ifndef emuH
#define emuH
//---------------------------------------------------------------------------
#endif

#define OPKEY_OFFSET 0x210
#define OPKEY_LEN 0xB
#define OPKEY_END 0xFFE
#define SIG_UPD_OFFSET  0x203
#define KEY_IDX_OFFSET  0x204
#define UPD_FLAG_OFFSET  0x202
#define KEY_IDX2_OFFSET  0xFFC
#define KEY_IDX3_OFFSET  0xFFD

// flag for RSA_KEYS buffer

#define RSA_CHANGED  0xFFD 

#define RESULT 0x20B
#define CA_SYS 0x20C
#define IDENT  0x20D
#define KEYIDX 0x20F

// CA systems
#define SECA 0x10
#define VIAC 0x20
#define NAGRA 0x30
#define IRDETO 0x40
#define CONAX 0x50
#define CRYPTO 0x60
#define SKYCRYPT 0x70
#define DREAMCRYPT 0x80
#define NDS 0x90
#define BISS 0xA0
#define CONST_CW 0xFF

// seca offsets
#define S_PPUA_OFFSET 0x10
#define S_ID_LEN 2
#define S_PPUA_LEN 4
#define S_PROV_NUM 8
// viac offsets
#define VIA_ID_OFFSET 0x30
#define VIA_ID_LEN 3
#define VIA_PPUA_OFFSET 0x6C
#define VIA_PPUA_LEN 4
#define VIA_UA_OFFSET 0xBC
#define VIA_UA_LEN 5
// irdeto offsets
#define IRD_HMK_OFFSET 0x160
#define IRD_PMK_OFFSET 0x1BA
#define IRD_HMK_LEN 10
#define IRD_PMK_LEN 8
#define IRD_PG_OFFSET 0x12A
#define IRD_HSN_OFFSET 0x145
#define IRD_PG_LEN 3
#define IRD_HSN_LEN 3
// nagra offsets
#define NGR_ID_OFFSET 0x120
#define NGR_ID_LEN 2
#define NGR_ID_NUM 5
// conax offsets

#ifndef byte
  #define byte unsigned char
#endif

typedef struct rsa_key_s {
   byte caid;
   byte key_id;
   byte key_type;
   byte key_len;
   } rkey_header;


#ifdef _cplusplus
extern "C" {
#endif
int update_keys(byte *buf_emu,byte *newkey, byte provIdx, byte casys);
byte *getkey(int keyidx, int providx, byte *buf_emu, byte casys);
#ifdef WIN32
int do_emm(byte *emm, byte ca_sys, byte *buf_emu);
int do_ecm(byte *ecm, byte *dw, byte *buf_emu);
#else        
int do_ecm(byte *ecm, byte *dw);
int do_emm(byte *emm, byte ca_sys);
#endif

int conax_ecm(byte *ecm,byte *dw,byte *emu_buf);
//int sky_ecm(byte *ecm,byte *dw,byte *key);
int tps2_decrypt(byte *ecm, int ea10_pos, byte *emu_buf);

// rsa_keys related functions
int update_rkey(byte *buf_emu, byte *newkey, rkey_header* k);
byte* get_rkey(int caid, int key_id, int key_type, byte* bufemu);
#ifdef _cplusplus
};
#endif




