//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <Inifiles.hpp>
#pragma hdrstop

#include "main.h"
#include "bufhead.h"
#include "foldlist.h"
#include "mhw.h"
#define _cplusplus
#include "emu.h"
#include "getput_key.h"
#include "strutils.h"
#undef _cplusplus

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TfrmMain *frmMain;
mhw_folder folder_list[0x10 * 8];
TIniFile *ini;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
	//bufsrv=(unsigned char*)malloc(BUF_SIZE);
	//bufkeys=(unsigned char*)malloc(BUF_SIZE);
	provi_changed=key_changed=data_changed=false;
	CASys = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Exit1Click(TObject *Sender)
{
	frmMain->Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Open1Click(TObject *Sender)
{
	SpeedButton12Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Save1Click(TObject *Sender)
{
	SpeedButton11Click(Sender);
}
//---------------------------------------------------------------------------


__fastcall TfrmMain::~TfrmMain()
{
	//TODO: Add your source code here
	//if(bufsrv) free(bufsrv);
	//if(bufkeys) free(bufkeys);
}
void __fastcall TfrmMain::OldEMU1Click(TObject *Sender)
{
   byte buf[0x100];
   mhw_file f;
   int fold_num, i, lst[10], fold_checked=0;
   byte *buf_emu=(byte*)malloc(2*BUF_SIZE+1);

   OpenDialog1->Filter = "Setting files(*.bin;*.rcu)|*.bin;*.rcu|All files(*.*)|*.*";
   if(!OpenDialog1->Execute()) return;
   lstIdents->Clear();
   FILE *settings=fopen(OpenDialog1->FileName.c_str(), "rb");
   fold_num=read_folders(settings, folder_list); // total number of folders
   frmList->lstFolders->Clear();
   for(i=0;i<fold_num;i++)
      frmList->lstFolders->Items->Add("Section " + AnsiString(folder_list[i].sect_id) + ": " + AnsiString(folder_list[i].name));
   frmList->lstFolders->ItemIndex = 0;
   if(frmList->ShowModal()== mrOk) {

      for(i=0; i<fold_num; i++)
	 if (frmList->lstFolders->Checked[i]) {
		mhw_file f;
		read_mhwfile(settings, &folder_list[i], &f);
		fseek(settings,folder_list[i].sect_id * 0x10000 + folder_list[i].offset + 10 + 2 + f.offset, 0);
		if(!strcmp(folder_list[i].name,"EMU"))
			fread(buf_emu,f.len,1,settings); // copy file content into emu buffer
		else if(!strcmp(folder_list[i].name,"RSA"))
			fread(buf_emu+BUF_SIZE,f.len,1,settings); // copy file content into emu buffer
		fold_checked ++; // count num of folders to send
	 }
   }
   if(fold_checked) {
	convert_old(buf_emu);
	data_changed = true;
   }
   lstCASys->ItemIndex = 0;
   lstCASysChange(NULL);
   pgInfo->ActivePageIndex = 0;
   free(buf_emu);
   fclose(settings);

}
//---------------------------------------------------------------------------

extern "C" int manage_keys(byte* request, byte* bufemu, int mode, int* offset);

int __fastcall TfrmMain::convert_old(unsigned char* buf_emu)
{
	//TODO: Add your source code here
	int caid, prov_id, key_id, len, type, offset, i, j, end_emu;
	byte request[0x100], *key, *buf_rsa = BUF_SIZE+buf_emu;
	// SECA idents and keys
	for(i=0;i<S_PROV_NUM;i++) {
		// insert SOID
		request[0]=SECA;
		request[2]=TYPE_SOID;
		request[LEN_BYTE]=S_ID_LEN;
		memcpy(request+HEADER_LEN, buf_emu+0+S_ID_LEN*i, S_ID_LEN);
		manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
		prov_id=bufsrv[offset+1];
		// insert PPUA
		if(buf_emu[S_PPUA_OFFSET+S_PPUA_LEN*i]|buf_emu[S_PPUA_OFFSET+S_PPUA_LEN*i+1]|
			buf_emu[S_PPUA_OFFSET+S_PPUA_LEN*i+2]|buf_emu[S_PPUA_OFFSET+S_PPUA_LEN*i+3]) {
			request[0]=SECA;
			request[1]=prov_id;
			request[2]=TYPE_SA;
			request[LEN_BYTE]=S_PPUA_LEN;
			memcpy(request+HEADER_LEN, buf_emu+S_PPUA_OFFSET+S_PPUA_LEN*i, S_PPUA_LEN);
			manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
		}
		// insert BUFEMU_E opkeys
		end_emu = buf_emu[BUF_END+1] + (buf_emu[BUF_END]<<8);
		for(j = OPKEY_OFFSET;j<end_emu;j+=OPKEY_LEN) {
			if((buf_emu[j] == SECA) &&
			    (buf_emu[j+1] == i+1)) {
				request[0]=SECA;
				request[1]=prov_id;
				request[2]=buf_emu[j+2];
				request[LEN_BYTE]=8;
				memcpy(request+HEADER_LEN, buf_emu+j+3, 8);
				manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
			}
		}

	 } // end seca
	 // viaccess
	 for(i=0;i<20;i++) {
		// insert soid
 		request[0]=VIAC;
		request[2]=TYPE_SOID;
		request[LEN_BYTE]=VIA_ID_LEN;
		memcpy(request+HEADER_LEN, buf_emu+VIA_ID_OFFSET+VIA_ID_LEN*i, VIA_ID_LEN);
		manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
		prov_id=bufsrv[offset+1];
		// insert PPUA
		if(buf_emu[VIA_PPUA_OFFSET+VIA_PPUA_LEN*i]|buf_emu[VIA_PPUA_OFFSET+VIA_PPUA_LEN*i+1]|
    			buf_emu[VIA_PPUA_OFFSET+VIA_PPUA_LEN*i+2]|buf_emu[VIA_PPUA_OFFSET+VIA_PPUA_LEN*i+3]) {
			request[0]=VIAC;
			request[1]=prov_id;
			request[2]=TYPE_SA;
			request[LEN_BYTE]=VIA_PPUA_LEN;
			memcpy(request+HEADER_LEN, buf_emu+VIA_PPUA_OFFSET+VIA_PPUA_LEN*i, VIA_PPUA_LEN);
			manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
		}
                // Insert UA
 		if(buf_emu[VIA_UA_OFFSET+VIA_UA_LEN*i]|buf_emu[VIA_UA_OFFSET+VIA_UA_LEN*i+1]|
    			buf_emu[VIA_UA_OFFSET+VIA_UA_LEN*i+2]|buf_emu[VIA_UA_OFFSET+VIA_UA_LEN*i+3]) {
			request[0]=VIAC;
			request[1]=prov_id;
			request[2]=TYPE_UA;
			request[LEN_BYTE]=VIA_UA_LEN;
			memcpy(request+HEADER_LEN, buf_emu+VIA_UA_OFFSET+VIA_UA_LEN*i, VIA_UA_LEN);
			manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
		}
		// insert BUFEMU_E opkeys
		end_emu = buf_emu[BUF_END+1] + (buf_emu[BUF_END]<<8);
		for(j = OPKEY_OFFSET;j<end_emu;j+=OPKEY_LEN) {
			if((buf_emu[j] == VIAC) &&
			    (buf_emu[j+1] == i+1)) {
				request[0]=VIAC;
				request[1]=prov_id;
				key_id=buf_emu[j+2];
                                memcpy(request+HEADER_LEN, buf_emu+j+3, 8);
                                // manage 16 byte keys
                                if(key_id < 0x10) {
                                    key = getkey(key_id+0x10, i+1, buf_emu, VIAC);
                                    if(key) {
                                        memcpy(request+HEADER_LEN+8, key, 8);
                                        request[LEN_BYTE]=16;
                                    }
                                    else
				        request[LEN_BYTE]=8;
                                    request[2]= key_id;
                                    manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
				}
				
			}
		}
	 }  // end viaccess
	 // nagra (keys for nagra2 only!)
	for(i=0;i<NGR_ID_NUM;i++) {
		// insert 2 SOIDs for each emu nagra provi
		if(!(buf_emu[NGR_ID_OFFSET+NGR_ID_LEN*i]|buf_emu[NGR_ID_OFFSET+NGR_ID_LEN*i+1])) continue;
		request[0]=NAGRA;
		request[2]=TYPE_SOID;
		request[LEN_BYTE]=NGR_ID_LEN;
		request[HEADER_LEN] = buf_emu[NGR_ID_OFFSET+NGR_ID_LEN*i] & 0xfe;
		request[HEADER_LEN+1] = buf_emu[NGR_ID_OFFSET+NGR_ID_LEN*i+1];
		manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
		prov_id=bufsrv[offset+1];
		request[HEADER_LEN] |= 1;
		manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
		// insert RSA_KEYS opkeys
		end_emu = buf_rsa[BUF_END+1] + (buf_rsa[BUF_END]<<8);
		for(j = 0;j<end_emu;) {
			if(((buf_rsa[j] & 0xf0) == NAGRA) &&
			   ((buf_rsa[j] & 7) == i+1)) {
				request[0]=NAGRA;
				request[1]=prov_id + ((buf_rsa[j] > 3) & 1);
				request[2]=buf_rsa[j+1];
				request[LEN_BYTE]=buf_rsa[j+3];
				memcpy(request+HEADER_LEN, buf_rsa+j+4, request[LEN_BYTE]);
				manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
			}
			j+=(buf_rsa[j+3]+4);
		}

	 }// end nagra

	 // cryptoworks (RSA_KEYS only)
	 end_emu = buf_rsa[BUF_END+1] + (buf_rsa[BUF_END]<<8);
	 for(j = 0;j<end_emu;) {
		if((buf_rsa[j] & 0xf0) == CRYPTO) {
			request[0] = CRYPTO;
			request[2]=TYPE_SOID;
			request[LEN_BYTE]=3; // cryptoworks provi len
			request[HEADER_LEN] = 0x0d;
			request[HEADER_LEN+1] = (buf_rsa[j]&0xf);
			request[HEADER_LEN+2] = buf_rsa[j+2];
			manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
			prov_id=bufsrv[offset+1];
			// copy key
			request[2] = buf_rsa[j+1];
			request[1]=prov_id;
			request[LEN_BYTE]= buf_rsa[j+3];
			memcpy(request+HEADER_LEN, buf_rsa+j+4, request[LEN_BYTE]);
			manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
		}
		j+=(buf_rsa[j+3]+4);
	 }
         return 0;
}



void __fastcall TfrmMain::list_provis(int ca_id)
{
	//TODO: Add your source code here
	int end_emu = bufsrv[BUF_END+1] + (bufsrv[BUF_END]<<8);
	int offset = 0;
	byte* rec, request[HEADER_LEN];
	request[0] = ca_id;
	request[LEN_BYTE]=1; // enum provis
	while(offset < end_emu) {
		manage_keys(request,bufsrv,MODE_GETNEXT,&offset);
		if(offset < end_emu) {
                        /*if(ca_id == BISS) {
                               lstIdents->Items->Add(bin2str(bufsrv+offset+1, 2)); // list SID
                               txtOther->Text =  bin2str(bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]);
                        }
			else */
                        if(bufsrv[offset+2] == TYPE_SOID)
				lstIdents->Items->Add( bin2str(bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]));
			offset += (bufsrv[offset+LEN_BYTE]+HEADER_LEN);
		}

	}
	provi_changed = false;
}

AnsiString __fastcall TfrmMain::bin2str(byte* buf, int len)
{
	//TODO: Add your source code here
	AnsiString S="", s;
	for(int i=0; i<len; i++) {
		s.printf("%02X",buf[i]);
		S += s;
	}
	return S;

}

int hex2int(char c)
{
        //TODO: Add your source code here
        int i=-1;
        switch(c){
           case '0':i=0; break;
           case '1':i=1; break;
           case '2':i=2; break;
           case '3':i=3; break;
           case '4':i=4; break;
           case '5':i=5; break;
           case '6':i=6; break;
           case '7':i=7; break;
           case '8':i=8; break;
           case '9':i=9; break;
           case 'a':
           case 'A':i=10; break;
           case 'b':
           case 'B':i=11; break;
           case 'c':
           case 'C':i=12; break;
           case 'd':
           case 'D':i=13; break;
           case 'e':
           case 'E':i=14; break;
           case 'f':
           case 'F':i=15; break;
           default: i=-1;
        }
        return i;
}

int TfrmMain::hex2bin(char* in, unsigned char* out)
{
        int i, half, nibble;
        i=half=0;
        while(*in) {
            nibble=hex2int(*in);
            in++;
            if(nibble != -1) {
                 if(half) {
                     out[0] |= (nibble&0xf);
                     out++; i++;
                 }
                 else {
                     out[0] = nibble<<4;
                 }
                 half = (half+1)&1;
            }

        }
        return i;
}
void __fastcall TfrmMain::lstIdentsClick(TObject *Sender)
{
	byte request[0x100];
	AnsiString keyID;
	if(!lstIdents->Items->Count)  return;
	SOID= lstIdents->Items->Strings[lstIdents->ItemIndex];
	if(provi_changed) {
	   if(MessageDlg("Provi data changed.\nSave it?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
	       SpeedButton7Click(NULL);
	       data_changed = true;
	   }
	}

	int len=hex2bin(SOID.c_str(), request+HEADER_LEN);
	int offset=0;
	clear_keys();
	request[0] = CASys;
	request[LEN_BYTE] = len;
	manage_keys(request,bufsrv,MODE_GETPROV,&offset);
	ProvID=request[1];
	int end_emu = bufsrv[BUF_END+1] + (bufsrv[BUF_END]<<8);
	if(offset < end_emu) {
		// display provi attributes
		offset=0;
		request[LEN_BYTE]=2; // enumerate keys
		while(offset < end_emu) {
			manage_keys(request,bufsrv,MODE_GETNEXT,&offset);
			if(offset < end_emu) {
				switch(bufsrv[offset+2]) {
				case TYPE_UA:
					txtUA->Text= bin2str(bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]);
					break;
				case TYPE_SA:
					txtSA->Text= bin2str(bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]);
					break;
				case TYPE_INFO:
					txtName->Text = AnsiString((char*)bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]);
					break;
                                case TYPE_FLAGS:
                                     chkPref->Checked = bufsrv[offset+HEADER_LEN] & 1;
                                     chkShar->Checked = bufsrv[offset+HEADER_LEN] & 2;
                                     chkDCW->Checked = bufsrv[offset+HEADER_LEN] & 4;
                                     chk3->Checked = bufsrv[offset+HEADER_LEN] & 8;
                                     break;
				default:
					txtOther->Text= bin2str(bufsrv+offset+2,1)+" "+bin2str(bufsrv+offset+HEADER_LEN,bufsrv[offset+LEN_BYTE]);
				}
				offset += (bufsrv[offset+LEN_BYTE]+HEADER_LEN);
			}

		}
		// display keys
		offset = 0;
		end_emu = bufkeys[BUF_END+1] + (bufkeys[BUF_END]<<8);
		while(offset < end_emu) {
			manage_keys(request,bufkeys,MODE_GETNEXT,&offset);
			if(offset < end_emu) {
				lstKeys->Items->Add(
				  bin2str(bufkeys+offset+2,1)+" "
				  +bin2str(bufkeys+offset+LEN_BYTE,1)+" "
				  +bin2str(bufkeys+offset+HEADER_LEN,bufkeys[offset+LEN_BYTE]));
				offset += (bufkeys[offset+LEN_BYTE]+HEADER_LEN);
			}
		}
	}
	shtKeys->Caption = SOID+" Keys";
        provi_changed = false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::clear_keys()
{
	//TODO: Add your source code here
	lstKeys->Clear();
	txtUA->Text = "";
	txtSA->Text = "";
	txtName->Text = "";
	txtOther->Text = "";
	chkPref->Checked=false;
	chkShar->Checked=false;
	chkDCW->Checked=false;
	chk3->Checked=false;
	shtKeys->Caption = "Keys";
}
void __fastcall TfrmMain::lstCASysChange(TObject *Sender)
{
	clear_keys();
	lstIdents->Clear();
   	TIniFile *ini;
   	ini = new TIniFile(
      		ChangeFileExt( Application->ExeName, ".INI" ) );
        CASys=ini->ReadInteger("CAS",lstCASys->Items->Strings[lstCASys->ItemIndex], 0xff);
        delete ini;
	list_provis(CASys);
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::SpeedButton9Click(TObject *Sender)
{
	panKey->Visible = false;
	lstKeys->Color = clWhite;
	panKeyMgr->Enabled= true;
	lstKeys->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton2Click(TObject *Sender)
{
	if(SOID == "") return;
	txtKeyID->Text = "";
	txtKeyLen->Text = "";
	txtKeyVal->Text = "";
	panKey->Visible = true;
	lstKeys->Color = clInactiveCaption;
	panKeyMgr->Enabled= false;
	lstKeys->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton3Click(TObject *Sender)
{
	byte* request = (byte*)malloc(txtKeyVal->Text.Length()/2 + HEADER_LEN);
	int len = hex2bin(txtKeyVal->Text.c_str(),request+HEADER_LEN), offset = 0;
	request[0] = CASys;
	request[1] = ProvID;
	request[2] = StrToInt("$"+txtKeyID->Text);
        if(txtKeyLen->Text == "") // set calculated length
        	request[LEN_BYTE] = len;
        else     // set declared length
		request[LEN_BYTE] = StrToInt("$"+txtKeyLen->Text);
	if (len != request[LEN_BYTE]) {
		ShowMessage("Declared key length is not equal to length of key value!\nCheck content of form fields.");
		free(request);
		return;
	}
	manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
	free(request);
	panKey->Visible = false;
	lstKeys->Color = clWhite;
	panKeyMgr->Enabled= true;
	lstKeys->Enabled = true;
	data_changed = true;
	lstIdentsClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton1Click(TObject *Sender)
{
	if(lstKeys->ItemIndex == -1) return;
	if(! lstKeys->Items->Count) return;
	AnsiString S= lstKeys->Items->Strings[lstKeys->ItemIndex];
	int TotalLen = S.Length();
	txtKeyID->Text = S.SubString(1,2);
	txtKeyLen->Text = S.SubString(4,2);
	txtKeyVal->Text = S.SubString(7,TotalLen - 6);
	panKey->Visible = true;
	lstKeys->Color = clInactiveCaption;
	panKeyMgr->Enabled= false;
	lstKeys->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::lstKeysClick(TObject *Sender)
{
 if(! lstKeys->Items->Count) return;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
     // Clear buffers
     bufsrv[BUF_END] = 0;
     bufsrv[BUF_END+1] = 0;
     bufkeys[BUF_END] = 0 ;
     bufkeys[BUF_END+1] = 0;
	pgInfo->ActivePageIndex = 0;
	provi_changed = false;
	data_changed = false;
        AppDir = ExtractFilePath(Application->ExeName);
   	TIniFile *ini;
   	ini = new TIniFile(
      		ChangeFileExt( Application->ExeName, ".INI" ) );
        ini->ReadSection("CAS",lstCASys->Items);
        delete ini;



}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton4Click(TObject *Sender)
{
	if(lstKeys->ItemIndex == -1) return;
	if(! lstKeys->Items->Count) return;
	if(MessageDlg("Delete Key?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo) return;
	byte request[HEADER_LEN];
	int offset = 0;
	AnsiString S= lstKeys->Items->Strings[lstKeys->ItemIndex];
	request[0] = CASys;
	request[1] = ProvID;
	request[2] = StrToInt("$"+S.SubString(1,2));
	manage_keys(request,bufkeys,MODE_DELKEY,&offset);
	data_changed = true;
	lstIdentsClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton6Click(TObject *Sender)
{
	if(lstCASys->Items->Count==0) return;
	if(lstCASys->ItemIndex== -1) return;
	AnsiString S=InputBox("New SOID","Add new provider","");
	if(S=="") return;
	byte request[0x100];
	request[0] = CASys;
	request[2]=TYPE_SOID;
	int len = hex2bin(S.c_str(),request+HEADER_LEN), offset = 0;
	request[LEN_BYTE]=len;
	manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
	if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	}
	lstIdents->Items->Add(S.UpperCase());
        data_changed = true;
	lstIdents->ItemIndex = lstIdents->Items->Count - 1;
	lstIdentsClick(NULL);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton5Click(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	AnsiString S=InputBox("Edit SOID","Replace provider",lstIdents->Items->Strings[lstIdents->ItemIndex]);
	if(S==lstIdents->Items->Strings[lstIdents->ItemIndex]) return;
	int offset = 0;
	byte request[0x100];
	// remove SOID record
	request[0] = CASys;
	request[1] = ProvID;
	request[2]=TYPE_SOID;
	manage_keys(request,bufsrv,MODE_DELKEY,&offset);
        lstIdents->Items->Delete(lstIdents->ItemIndex);
	// add new SOID record
	int len = hex2bin(S.c_str(),request+HEADER_LEN);
	request[LEN_BYTE]=len;
	manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
	if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	}
	data_changed = true;
	lstIdents->Items->Add(S.UpperCase());
	lstIdents->ItemIndex = lstIdents->Items->Count - 1;
	lstIdentsClick(NULL);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton8Click(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	if(MessageDlg("Delete Provider and all it's keys?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo) return;
	AnsiString S= lstIdents->Items->Strings[lstIdents->ItemIndex];
	byte request[0x100];
	int offset;
	// delete all keys
	request[0] = CASys;
	request[1] = ProvID;
	manage_keys(request,bufkeys,MODE_DELALL,&offset);
	// remove provi and it's attributes
	request[2] = TYPE_SOID;
	request[LEN_BYTE] = hex2bin(S.c_str(),request+HEADER_LEN);
	manage_keys(request,bufsrv,MODE_DELPROV,&offset);
	data_changed = true;
	lstCASysChange(NULL);

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton7Click(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	//============ provi attributes =============
	AnsiString S;
	int len, offset;
	byte request[0x100];

	provi_changed = false;
	// UA
	S = txtUA->Text;
	if(Trim(S).Length()) {
	   request[0] = CASys;
	   request[1] = ProvID;
	   request[2] = TYPE_UA;
	   len = hex2bin(S.c_str(),request+HEADER_LEN); offset = 0;
	   request[LEN_BYTE]=len;
	   manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	   }
	   data_changed = true;
	}
	// SA
	S = txtSA->Text;
	if(Trim(S).Length()) {
	   request[0] = CASys;
	   request[1] = ProvID;
	   request[2] = TYPE_SA;
	   len = hex2bin(S.c_str(),request+HEADER_LEN); offset = 0;
	   request[LEN_BYTE]=len;
	   manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	   }
	   data_changed = true;
	}
	// Info
	S = txtName->Text;
	if(Trim(S).Length()) {
	   request[0] = CASys;
	   request[1] = ProvID;
	   request[2] = TYPE_INFO;
	   len = S.Length();
	   request[LEN_BYTE]=len+1;
	   memcpy(request+HEADER_LEN,S.c_str(),len);
	   request[HEADER_LEN+len] = 0; // finalize C-string
	   manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	   }
	   data_changed = true;
	}
        // Flags
        int i = (int)chkPref->Checked + (int)chkShar->Checked * 2 + (int)chkDCW->Checked * 4 + (int)chk3->Checked * 8;
        if(i) {
	   request[0] = CASys;
	   request[1] = ProvID;
	   request[2] = TYPE_FLAGS;
	   request[LEN_BYTE]=1;
	   request[HEADER_LEN] = i;
	   manage_keys(request,bufsrv,MODE_PUTKEY,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
		return;
	   }
	   data_changed = true;

        }

}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::SpeedButton11Click(TObject *Sender)
{
	if(!SaveDialog1->Execute()) return;
	byte* buf=(byte*)malloc(FLASH_SECTOR_SIZE);
	memset(buf,0,FLASH_SECTOR_SIZE);
	write_mhw_file(buf,"EMU","EMU",bufsrv,0x1000);
	write_mhw_file(buf,"RSA","RSA_KEYS",bufkeys,0x1000);
	FILE *f=fopen(SaveDialog1->FileName.c_str(), "wb");
	fwrite(buf,1,FLASH_SECTOR_SIZE,f);
	fclose(f);
	free(buf);
	data_changed = false;
   	provi_changed = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton12Click(TObject *Sender)
{
   mhw_file f;
   int fold_num, i, lst[10], isEmu, isRsa;
   //byte *buf_emu=(byte*)malloc(2*BUF_SIZE+1);
   // close all
   SpeedButton13Click(NULL);

   OpenDialog1->Filter = "Settings files(*.bin;*.rcu)|*.bin;*.rcu|All files(*.*)|*.*";
   isEmu=isRsa=0;
   if(!OpenDialog1->Execute()) return;

   lstIdents->Clear();
   FILE *settings=fopen(OpenDialog1->FileName.c_str(), "rb");
   fold_num=read_folders(settings, folder_list); // total number of folders
      for(i=0; i<fold_num; i++)
      {
		mhw_file f;
		read_mhwfile(settings, &folder_list[i], &f);
		fseek(settings,folder_list[i].sect_id * 0x10000 + folder_list[i].offset + 10 + 2 + f.offset, 0);
		if(!strcmp(folder_list[i].name,"EMU"))  {
			isEmu = 1;
			fread(bufsrv,f.len,1,settings); // copy file content into service buffer
		}
		else if(!strcmp(folder_list[i].name,"RSA")) {
			fread(bufkeys,f.len,1,settings); // copy file content into key buffer
			isRsa = 1;
		}
      }
   fclose(settings);
   if(!isEmu) {
	ShowMessage("Section EMU not found!");
	return;
   }
   if(!isRsa) {
	ShowMessage("Section RSA not found!");
	return;
   }
   lstCASys->ItemIndex = 0;
   lstCASysChange(NULL);
   pgInfo->ActivePageIndex = 0;
   data_changed = false;
   provi_changed = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::txtNameChange(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;

}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::txtUAChange(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::txtSAChange(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::txtOtherChange(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkPrefClick(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkSharClick(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chkDCWClick(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::chk3Click(TObject *Sender)
{
	if(lstIdents->Items->Count==0) return;
	if(lstIdents->ItemIndex== -1) return;
	provi_changed = true;
	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::SpeedButton10Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
     if(data_changed) {
	if(MessageDlg("Data changed.\nSave befor exit?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
	       SpeedButton11Click(NULL);
	}
     }
     CanClose = True;

}
//---------------------------------------------------------------------------
#include "sc_list.h"
WordArray arr;

void __fastcall TfrmMain::SoftCamkey1Click(TObject *Sender)
{
   OpenDialog1->Filter = "SoftCam files(*.key;*.txt)|*.key;*.txt|All files(*.*)|*.*";
   if(!OpenDialog1->Execute()) return;
   frmSoftCam->lstKeys->Clear();
   frmSoftCam->lstKeys->Items->LoadFromFile(OpenDialog1->FileName);
   frmSoftCam->ShowModal();
   if(frmSoftCam->ModalResult == mrCancel) return;
   unsigned char* soid;
   unsigned char * key;
   ini = new TIniFile(AppDir+"key_id.ini");
   for(int i=0; i< frmSoftCam->lstKeys->Items->Count; i++) {
          if(frmSoftCam->lstKeys->Checked[i]) {
              AnsiString S = frmSoftCam->lstKeys->Items->Strings[i];
              if(parse_line(S.c_str(),arr) > 3) { // valid key record
                 // arr contains parsed key records
                put_sc_key(arr[0],arr[1],arr[2],arr[3]);
              }
          }
   }
   delete ini;
   lstCASys->ItemIndex = 0;
   lstCASysChange(NULL);
   pgInfo->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------


int __fastcall TfrmMain::put_sc_key(char* ca, char* soid, char* key_id, char* key)
{
        //TODO: Add your source code here
        int i;
        switch(ca[0]) {
           case 'S': CASys = SECA; break;
           case 'N': CASys = NAGRA; break;
           case 'V': CASys = VIAC; break;
           case 'W': CASys = CRYPTO; break;
           case 'F': CASys = BISS; break;
           default: return 0; // unsupported CA system
        }
        int len = strlen(key), offset = 0;
        if(!len) return 0;
	byte* request = (byte*)malloc(len/2 + HEADER_LEN);
        // Put ident
        len = hex2bin(soid,request+HEADER_LEN);
        if(!len) return 0;
        request[0]=CASys;
        request[2]=TYPE_SOID;
        request[LEN_BYTE]=len;
        manage_keys(request,bufsrv,MODE_PUTPROV,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
                free(request);
		return 0;
	   }
        ProvID=bufsrv[offset+1];
        // insert key
        len = hex2bin(key,request+HEADER_LEN);
        if(!len) return 0;
	request[0] = CASys;
	request[1] = ProvID;
        switch(CASys) {
           case SECA:
           case VIAC:
           i=hex2bin(key_id,request+2);
           if(i != 1)
              return 0; // wrong key index
           break;
           case BISS:
           case CONST_CW:
           request[2] = i;
           break;
           default:
           i = convert_keyid(ca, key_id);
           if(i<0)
              return 0; // unsupported key index
           request[2] = i;
        }
	request[LEN_BYTE] = len;
	manage_keys(request,bufkeys,MODE_PUTKEY,&offset);
	   if(BUF_END <= offset) { // not enough room
		ShowMessage("Insufficient room for new data.");
                free(request);
		return 0;
	   }
	free(request);
        data_changed = true;
        return 1;
}

int __fastcall TfrmMain::convert_keyid(char* ca, char* keyid)
{
    AnsiString S=ini->ReadString(AnsiString(ca),AnsiString(keyid),"N");
    if(S == "N")
         return -1; // key id not resolved
    char k[1];
    hex2bin(S.c_str(), k);
    return k[0];
}
void __fastcall TfrmMain::SpeedButton13Click(TObject *Sender)
{
     // Query for save
     if(data_changed) {
	if(MessageDlg("Data changed.\nSave befor close?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
	       SpeedButton11Click(NULL);
	}
     }
     // clear lists
     lstIdents->Clear();
     clear_keys();
     lstIdents->Clear();
     pgInfo->ActivePageIndex = 0;
     // Clear buffers
     bufsrv[BUF_END] = 0;
     bufsrv[BUF_END+1] = 0;
     bufkeys[BUF_END] = 0;
     bufkeys[BUF_END+1] = 0;

     provi_changed = false;
     data_changed = false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::Close1Click(TObject *Sender)
{
   SpeedButton13Click(NULL);
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::lstKeysDblClick(TObject *Sender)
{
        SpeedButton1Click(NULL);        
}
//---------------------------------------------------------------------------

