//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "strutils.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

int is_digit(char c) {
    if((c > 0x2f) && (c < 0x3a)) return 1;
    return 0;
}

int is_alpha(char c) {
    if(((c > 0x40) && (c < 0x5b)) // capital letters
     ||((c > 0x60) && (c < 0x7b)) // low case letters
     ) return 1;
     return 0;
}

int is_alphanum(char c) {
   if(is_digit(c)) return 1;
   if(is_alpha(c)) return 1;
   return 0;
}

int skipspace(char* s) {
    int i=0;
    while(*s) {
       if(s[0] <= 0x20) i++;
       else break;
       s++;
    }
    return i; // return number of leading spaces 
}

char* get_word(char* s, int* len, int* is_last) {
   // skip leading spaces
   int i,j;
   j = i = skipspace(s);
   while(is_alphanum(s[i])) i++;
   // check, is it the last word in the string
   switch(s[i]) {
      case 0:
      case '\r':
      case '\n':
      case '#': // comments
      case ';':
         *is_last = 1;
         break;
      default:
         *is_last = 0;
   }
   // finalize C-string
   s[i] = 0;
   *len = i+1;
   return s+j;
}

int parse_line(char* s, WordArray a) {
   int i=0, last=0, len = 0;
   while((i <  MAX_WORDS_PER_LINE) && (!last)) {
      a[i] = get_word(s, &len, &last);
      s += len;
      i++;
   }
   return i;
}

